﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace TestNapLib
{
    public partial class EnglishThesaures : Form
    {
        public ArrayList  SubjectCategory;
        public ArrayList  DESCRIPTOR;
        public int lastmatch;
        private Form1 f0;
        public EnglishThesaures(Form1 f)
        {
            f0 = f;
            InitializeComponent();
            // read in XML
            //wait cursor while the nodes populate
            this.Cursor = Cursors.WaitCursor;
            //First, we'll load the Xml document
            XmlDocument xDoc = new XmlDocument();
            xDoc.Load("EnglishThesaurus.xml");
            //Now, clear out the treeview, 
            //and add the first (root) node
            treeView1.Nodes.Clear();
            treeView1.Nodes.Add(new
            TreeNode(xDoc.DocumentElement.Name));
            TreeNode tNode = new TreeNode();
            tNode = (TreeNode)treeView1.Nodes[0];
            //We make a call to addTreeNode, 
            //where we'll add all of our nodes
            addTreeNode(xDoc.DocumentElement, tNode);
            //Expand the treeview to show all nodes
            treeView1.ExpandAll();

            // read the file into a dataset
            listBox1.Items.Clear();
            SubjectCategory = new ArrayList();
            for (int i = 0; i < treeView1.Nodes[0].Nodes.Count; i++ )
            {
                // running through concepts
                TreeNodeCollection c = treeView1.Nodes[0].Nodes[i].Nodes;
                for ( int j = 0; j < c.Count; j++)
                {
                    if ( String.Compare(c[j].Text,"SubjectCategory") == 0 )
                    {
                        string t = c[j].Nodes[0].Text;
                        if (!SubjectCategory.Contains(t)) SubjectCategory.Add(t);
                    }
                }


            }
            SubjectCategory.Sort();
            for (int i = 0; i < SubjectCategory.Count; i++) listBox1.Items.Add(SubjectCategory[i]);



            this.Cursor = Cursors.Default;
        }
        //This function is called recursively until all nodes are loaded
        private void addTreeNode(XmlNode xmlNode, TreeNode treeNode)
        {
            XmlNode xNode;
            TreeNode tNode;
            XmlNodeList xNodeList;
            if (xmlNode.HasChildNodes) //The current node has children
            {
                xNodeList = xmlNode.ChildNodes;
                for (int x = 0; x <= xNodeList.Count - 1; x++)
                //Loop through the child nodes
                {
                    xNode = xmlNode.ChildNodes[x];
                    treeNode.Nodes.Add(new TreeNode(xNode.Name));
                    tNode = treeNode.Nodes[x];
                    addTreeNode(xNode, tNode);
                }
            }
            else //No children, so add the outer xml (trimming off whitespace)
                treeNode.Text = xmlNode.OuterXml.Trim();
        }

        private void label1_DoubleClick(object sender, EventArgs e)
        {
            // double click

        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {

        }

        private void treeView1_DoubleClick(object sender, EventArgs e)
        {
            // double click
            string selectedNode = this.treeView1.SelectedNode.Text;
            
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            // fill out concepts
            

            this.listBox2.Items.Clear();
            DESCRIPTOR = new ArrayList();
            string match; 
            for (int k = 0; k < listBox1.SelectedIndices.Count; k++  )
            {
                match = listBox1.SelectedItems[k].ToString();
                for (int i = 0; i < treeView1.Nodes[0].Nodes.Count; i++)
                {
                    // running through concepts
                    TreeNodeCollection c = treeView1.Nodes[0].Nodes[i].Nodes;
                    for (int j = 0; j < c.Count; j++)
                    {
                        if (String.Compare(c[j].Text, "SubjectCategory") == 0)
                        {
                            string t = c[j].Nodes[0].Text;
                            if (String.Compare(t, match) == 0)
                            {
                                // get descriptor 
                                if (String.Compare(c[0].Text, "DESCRIPTOR") == 0)
                                {
                                    if( !DESCRIPTOR.Contains(c[0].Nodes[0].Text) )  DESCRIPTOR.Add(c[0].Nodes[0].Text);
                                }
                            }
                        }
                    }


                }
            }

            DESCRIPTOR.Sort();
            for (int i = 0; i < DESCRIPTOR.Count; i++) listBox2.Items.Add(DESCRIPTOR[i]);

        }

        private void listBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            string match = this.listBox2.SelectedItem.ToString();
            listBox3.Items.Clear();
            listBox4.Items.Clear();
            listBox5.Items.Clear();
            listBox6.Items.Clear();
            for (int i = 0; i < treeView1.Nodes[0].Nodes.Count; i++)
            {
                // running through concepts
                TreeNodeCollection c = treeView1.Nodes[0].Nodes[i].Nodes;
                for (int j = 0; j < c.Count; j++)
                {

                            // get descriptor 
                            if (String.Compare(c[0].Text, "DESCRIPTOR") == 0)
                            {
                                string t = c[0].Nodes[0].Text;
                                if ( String.Compare(match,t) == 0)
                                {
                                    for ( int k = 1; k < c.Count; k++ )
                                    {
                                        if ( String.Compare(c[k].Text, "BroaderTerm") == 0 )
                                        {
                                            listBox3.Items.Add(c[k].Nodes[0].Text);
                                        }
                                        if ( String.Compare(c[k].Text, "NarrowerTerm") == 0 )
                                        {
                                            listBox4.Items.Add(c[k].Nodes[0].Text);
                                        }
                                        if ( String.Compare(c[k].Text, "RelatedTerm") == 0 )
                                        {
                                            listBox5.Items.Add(c[k].Nodes[0].Text);
                                        }
                                        if ( String.Compare(c[k].Text, "UsedFor") == 0 )
                                        {
                                            listBox6.Items.Add(c[k].Nodes[0].Text);
                                        }
                                        if ( String.Compare(c[k].Text, "Use") == 0 )
                                        {
                                            listBox6.Items.Add(c[k].Nodes[0].Text);
                                        }
                                    }
                                    break;
                                }
                            }
                       
                }


            }
        }

        private void listBox4_SelectedIndexChanged(object sender, EventArgs e)
        {
            lastmatch = listBox2.SelectedIndex;
            string match = listBox4.SelectedItem.ToString();
            // find in key word
            if(listBox2.Items.Contains(match))
            {
                int i = listBox2.Items.IndexOf(match);
                listBox2.SelectedIndex = i;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            listBox2.SelectedIndex = lastmatch;
        }

        private void listBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            lastmatch = this.listBox2.SelectedIndex;
            string match = listBox3.SelectedItem.ToString();
            // find in key word
            if (listBox2.Items.Contains(match))
            {
                int i = listBox2.Items.IndexOf(match);
                listBox2.SelectedIndex = i;
            }
        }

        private void listBox5_SelectedIndexChanged(object sender, EventArgs e)
        {
            lastmatch = this.listBox2.SelectedIndex;
            string match = listBox5.SelectedItem.ToString();
            // find in key word
            if (listBox2.Items.Contains(match))
            {
                int i = listBox2.Items.IndexOf(match);
                listBox2.SelectedIndex = i;
            }
        }

        private void listBox2_DoubleClick(object sender, EventArgs e)
        {
            f0.AddToKeyWordList(this.listBox2.SelectedItem.ToString());
        }
    }
}
